## python3.8 3.8.0

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python3
VENVDIR      = ./venv
SPHINXBUILD  = PATH=$(VENVDIR)/bin:$$PATH sphinx-build
BLURB        = PATH=$(VENVDIR)/bin:$$PATH blurb
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)
SPHINXERRORHANDLING = -W

# Internal variables.
PAPEROPT_a4     = -D latex_elements.papersize=a4paper
PAPEROPT_letter = -D latex_elements.papersize=letterpaper

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees $(PAPEROPT_$(PAPER)) \
                $(SPHINXOPTS) $(SPHINXERRORHANDLING) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text texinfo changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable venv

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  texinfo    to make Texinfo file"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

build:
	-mkdir -p build
# Look first for a Misc/NEWS file (building from a source release tarball
# or old repo) and use that, otherwise look for a Misc/NEWS.d directory
# (building from a newer repo) and use blurb to generate the NEWS file.
	@if [ -f  ../Misc/NEWS ] ; then \
		echo "Using existing Misc/NEWS file"; \
		cp ../Misc/NEWS build/NEWS; \
	elif $(BLURB) help >/dev/null 2>&1 && $(SPHINXBUILD) --version >/dev/null 2>&1; then \
		if [ -d ../Misc/NEWS.d ]; then \
			echo "Building NEWS from Misc/NEWS.d with blurb"; \
			$(BLURB) merge -f build/NEWS; \
		else \
			echo "Neither Misc/NEWS.d nor Misc/NEWS found; cannot build docs"; \
			exit 1; \
		fi \
	else \
		echo ""; \
		echo "Missing the required blurb or sphinx-build tools."; \
		echo "Please run 'make venv' to install local copies."; \
		echo ""; \
		exit 1; \
	fi
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

texinfo: BUILDER = texinfo
texinfo: build
	@echo "Build finished; the python.texi file is in build/texinfo."
	@echo "Run \`make info' in that directory to run it through makeinfo."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/susp-ignored.csv."; \
	false; }

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/* $(VENVDIR)/*

venv:
	$(PYTHON) -m venv $(VENVDIR)
	$(VENVDIR)/bin/python3 -m pip install -U pip setuptools
	$(VENVDIR)/bin/python3 -m pip install -U Sphinx blurb python-docs-theme
	@echo "The venv has been created in the $(VENVDIR) directory"

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

	# archive the texinfo build
	rm -rf build/texinfo
	make texinfo
	make info --directory=build/texinfo
	cp -pPR build/texinfo dist/python-$(DISTVERSION)-docs-texinfo
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-texinfo.tar python-$(DISTVERSION)-docs-texinfo
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-texinfo.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-texinfo.zip python-$(DISTVERSION)-docs-texinfo)
	rm -r dist/python-$(DISTVERSION)-docs-texinfo
	rm dist/python-$(DISTVERSION)-docs-texinfo.tar

check:
	$(PYTHON) tools/rstlint.py -i tools -i $(VENVDIR) -i README.rst

serve:
	$(PYTHON) ../Tools/scripts/serve.py build/html

# Targets for daily automated doc build
# By default, Sphinx only rebuilds pages where the page content has changed.
# This means it doesn't always pick up changes to preferred link targets, etc
# To ensure such changes are picked up, we build the published docs with
# `-E` (to ignore the cached environment) and `-a` (to ignore already existing
# output files)

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1 -A switchers=1'
	-make suspicious

# for quick rebuilds (HTML only)
autobuild-dev-html:
	make html SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1 -A switchers=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev-html

## python3.8 3.8.0~a3

=== debian/changelog ===
python3.8 (3.8.0~a3-2) experimental; urgency=medium

  * d/p/arm-alignment.diff: Don't allow unaligned memory accesses in the
    _sha3 extension (Dave Jones). LP: #1821869. Issue #36515.
  * Tweak the asyncio/ssl test again.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Apr 2019 09:37:42 +0200

python3.8 (3.8.0~a3-1) experimental; urgency=medium

  * Python 3.8.0 alpha 3 release.
  * Work around issue #35988, reducing the payload size for the asyncio/ssl
    tests.

 -- Matthias Klose <doko@debian.org>  Tue, 26 Mar 2019 10:17:13 +0100

python3.8 (3.8.0~a2-1ubuntu1) disco; urgency=medium

  * Update to 20190314 from the trunk.
  * Use a build profile for libbluetooth-dev (<!pkg.python3.8.nobluetooth>).

 -- Matthias Klose <doko@debian.org>  Thu, 14 Mar 2019 16:06:36 +0100

python3.8 (3.8.0~a2-1) experimental; urgency=medium

  * Python 3.8.0 alpha 2 release.
  * Update symbols files and refresh patches.

 -- Matthias Klose <doko@debian.org>  Thu, 14 Mar 2019 10:20:00 +0100

python3.8 (3.8.0~a1-1) experimental; urgency=medium

  * Python 3.8.0 alpha 1 release.
  * Update VCS attributes.
  * Refresh patches.
  * Update symbols files.
  * Fix some lintian warnings.
  * Add pathlib to the set of the minimal modules.

 -- Matthias Klose <doko@debian.org>  Wed, 06 Feb 2019 16:07:30 +0100

python3.7 (3.7.1-1) unstable; urgency=medium

  * Python 3.7.1 release.

 -- Matthias Klose <doko@debian.org>  Sun, 21 Oct 2018 10:03:53 +0200

python3.7 (3.7.1~rc2-1) unstable; urgency=medium

  * Python 3.7.1 release candidate 2.

 -- Matthias Klose <doko@debian.org>  Mon, 15 Oct 2018 11:24:12 +0200

python3.7 (3.7.1~rc1-1) unstable; urgency=medium

  * Python 3.7.1 release candidate 1.

 -- Matthias Klose <doko@debian.org>  Thu, 27 Sep 2018 11:41:42 +0200

python3.7 (3.7.0-7) unstable; urgency=medium

  * Update to 20180925 from the 3.7 branch.
  * Don't run OpenSSL related tests during the build. Hanging on
    some buildds.

 -- Matthias Klose <doko@debian.org>  Tue, 25 Sep 2018 16:01:24 +0200

python3.7 (3.7.0-6) unstable; urgency=medium

  * Update to 20180901 from the 3.7 branch.
    - Fixes the build with OpenSSL 1.1.1. Closes: #907031.
  * Don't run the test_ftplib and test_ssl autopkg tests, not yet ready
    for OpenSSL 1.1.1.

 -- Matthias Klose <doko@debian.org>  Sat, 01 Sep 2018 01:21:37 +0200

python3.7 (3.7.0-5) unstable; urgency=medium

  * Update to 20180820 from the 3.7 branch.
  * Avoid usage of distutils in the platform module. See issue #26544.
  * Fix some issues on architectures from the computer museum (Jason Duerstock).
    Closes: #905536.
    - Disable -O3 on ia64 (see PR rtl-optimization/85412).
    - Remove the -O2 override on m68k (see Debian #326903).
    - Remove the -mieee and -O2 overrides for DEC Alpha (see Debian #212912).
  * Add more breaks for packages not compatible with Python 3.7:
    - python3-aiomeasures. See #906159.
    - python3-motor (updated). See #903527.
  * Again close the RC issue about the syntax errors triggered by Python 3.7.
    Closes: #902788.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Mon, 20 Aug 2018 19:52:20 +0200

python3.7 (3.7.0-4) unstable; urgency=medium

  * Update to 20180802 from the 3.7 branch.
  * Add more breaks for packages not compatible with Python 3.7:
    - python3-pyatspi. See #902989.
  * Move test/__main__.py into libpython3.7-stdlib.

 -- Matthias Klose <doko@debian.org>  Thu, 02 Aug 2018 08:46:56 +0200

python3.7 (3.7.0-3) unstable; urgency=medium

  * Update to 20180730 from the 3.7 branch.
  * Add more breaks for packages not compatible with Python 3.7:
    - python3-trollius. See #903888.
    - python3-sleekxmpp. See #904453.
    - voltron. See #904657.
    - visidata. See #904656.
    - salt-common. See #903654.
    - python3-yowsup. See #904653.
    - python3-websockets. See #904650.
    - python3-txfixtures. See #904649.
    - python3-tweepy. See #904648.
    - python3-slixmpp. See #904644.
    - python3-signaller. See #904642.
    - python3-rpyc. See #904615.
    - python3-protorpc-standalone. See #904603.
    - python3-nova. See #904587.
    - python3-murano. See #904581.
    - python3-mastodon. See #904579.
    - python3-hug. See #904576.
    - python3-async. See #904492.
    - python3-pylama. See #904491.
    - python3-exabgp. See #904390.
    - python3-glance. See #904389.
    - python3-gbulb. See #904388.
    - python3-engineio. See #904383.
    - python3-doublex. See #904382.
    - python3-dns. See #904381.
    - python3-opcua. See #904373.
    - openscap-daemon. See #904.
    - oca-core. See #904370.
    - patroni. See #904369.
    - python3-panoramisk. See #904368.
    - linux-show-player-. See #904367.
    - python3-cs. See #904365.
    - python3-azure. See #904364.
    - python3-applicationinsights. See #904363.
    - python3-aiopg. See #904361.
    - python3-aiozmq. See #904358.
    - python3-pysnmp4. See #904357.
    - python3-astroquery. See #904351.
    - snakemake. See #904350.
    - fail2ban. See #902817.
    - python3-morse-simulator. See #904343.
    - python3-tango. See #904298.
    - python3-pycuda. See #903826.
    - python3-pycsw. See #903784.
    - gnome3-builder. See #903558.
  * Close the RC issue about the syntax errors triggered by Python 3.7, now
    that all the breaks are in place. Closes: #902788.
  * Mark the lib2to3 and site tests as succeeding again, mark the tcl test
    as failing (issue #34178).

 -- Matthias Klose <doko@debian.org>  Mon, 30 Jul 2018 06:39:20 +0200

python3.7 (3.7.0-2) unstable; urgency=medium

  * Update to 20180720 from the 3.7 branch.
  * Add breaks for packages not compatible with Python 3.7:
    - python3-twisted. See #902766.
    - python3-pexpect. See #902646.
    - python3-cxx-dev. See #902673.
    - libboost-python1.62.0. See #902702.
    - python3-psycopg2. See #902715.
    - python3-maxminddb. See #902756.
    - python3-blist. See #902757.
    - python3-django. See #902761.
    - diffoscope. See #902650.
    - gpodder. See #902704.


=== debian/control ===
Source: python3.8
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev, libncursesw5-dev (>= 5.3), 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.4),
  libbluetooth-dev [linux-any] <!pkg.python3.8.nobluetooth>,
  locales-all,
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  mime-support, netbase, bzip2, time, python3:any,
  net-tools, xvfb, xauth
Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/cpython-team/python3
Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
XS-Testsuite: autopkgtest

Package: python3.8
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.8-minimal (= ${binary:Version}),
 libpython3.8-stdlib (= ${binary:Version}),
 mime-support,
 ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.8-venv, python3.8-doc, binutils
Breaks: python3-all (<< 3.6.5~rc1-1),
  python3-dev (<< 3.6.5~rc1-1),
  python3-venv (<< 3.6.5-2), ${python38:Breaks}
Description: Interactive high-level object-oriented language (version 3.8)
 Python is a high-level, interactive, object-oriented language. Its 3.8 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.8-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.8 (= ${binary:Version}),
 python-pip-whl (>= 8.1.0-2), ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.8)
 Python is a high-level, interactive, object-oriented language. Its 3.8 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.8 binary.

Package: libpython3.8-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.8-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Description: Interactive high-level object-oriented language (standard library, version 3.8)
 Python is a high-level, interactive, object-oriented language. Its 3.8 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.8's standard library. It is normally not
 used on its own, but as a dependency of python3.8.

Package: python3.8-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.8-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.8
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.8)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.8-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython3.8-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.8-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.8)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.8-minimal.

Package: libpython3.8
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.8-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.8)
 Python is a high-level, interactive, object-oriented language. Its 3.8 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.8-examples
Architecture: all
Depends: python3.8 (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.8)
 Examples, Demos and Tools for Python (v3.8). These are files included in
 the upstream Python distribution (v3.8).

Package: python3.8-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.8 (= ${binary:Version}), libpython3.8-dev (= ${binary:Version}), libpython3.8 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.8)
 Header files, a static library and development tools for building
 Python (v3.8) modules, extending the Python interpreter or embedding
 Python (v3.8) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.8-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.8-stdlib (= ${binary:Version}), libpython3.8 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.8)
 Header files, a static library and development tools for building
 Python (v3.8) modules, extending the Python interpreter or embedding
 Python (v3.8) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.8-dev.

Package: libpython3.8-testsuite
Section: libdevel
Architecture: all
Depends: python3.8 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.8)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.8-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.8-stdlib package).

Package: idle-python3.8
Architecture: all
Depends: python3.8, python3-tk, python3.8-tk,
  ${misc:Depends},
  libjs-mathjax,
Enhances: python3.8
Description: IDE for Python (v3.8) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.8).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.8-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.8
Description: Documentation for the high-level object-oriented language Python (v3.8)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.8). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.8
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.8-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python3.8 (= ${binary:Version}), libpython3.8-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.8)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.8-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.8-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Debug Build of the Python Interpreter (version 3.8)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export DEB_BUILD_MAINT_OPTIONS=hardening=-pie
dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) dpkg-buildflags

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative      := $(shell \
	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
	elif dpkg-vendor --derives-from Debian; then echo Debian; \
	else echo Unknown; fi)

VER=3.8
SVER=3.8.0~a1
NVER=3.9
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++
ifneq (,$(filter $(distrelease),bionic))
  CC=$(DEB_HOST_GNU_TYPE)-gcc-8
  CXX=$(DEB_HOST_GNU_TYPE)-g++-8
  bd_gcc = g++-8,
endif

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

# on ia64, disable -O3 until gcc bug #85412 is fixed
ifeq ($(DEB_HOST_ARCH),ia64)
    EXTRA_OPT_CFLAGS += -O2
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif
with_pgo :=
with_lto :=

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

sysconfig_substflags = \
	-e 's,gcc-8,gcc,;s,g++-8,g++,' \
	-e '/^OPT/s,-O3,-O2,' \
	-e 's/-O3/-O2/g;s/$(LTO_CFLAGS)//g' \
	-e 's/-fprofile-use *-fprofile-correction//g' \
	-e 's/-fstack-protector /-fstack-protector-strong /g' \
	-e 's/-specs=[^ ]*//g' \
	-e 's/-fdebug-prefix-map=[^ ]*//g' \
	-e 's,^RUNSHARED *=.*,RUNSHARED=,' \
	-e '/BLDLIBRARY/s/-L\. //'

ifeq ($(derivative),Ubuntu)
  arch_substvars =
else ifeq ($(derivative),Debian)
  arch_substvars = # '-Vpython38:Breaks=$(shell tr '\n' ' ' < debian/py38-breaks.$(derivative))'
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg
p_udeb	:= $(PVER)-udeb
p_venv	:= $(PVER)-venv

p_lbase	:= lib$(PVER)-stdlib
p_lmin	:= lib$(PVER)-minimal
p_ldev	:= lib$(PVER)-dev

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential,
  locales-all,
  python3.8-dev,
  libpython3.8-testsuite,
  python3-gdbm,
  python3-distutils,
  python3-tk,
  idle-python3.8,
# need to turn off apport
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential,
  locales-all, python3.8-dev,
  python3.8-dbg,
  libpython3.8-testsuite,
  python3-gdbm-dbg,
  gdb,
  python3-distutils,
  python3-tk-dbg,
  idle-python3.8,
# need to turn off apport
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential,
  locales-all,
  python3.8-dev,
  libpython3.8-testsuite,
  python3-gdbm,
  python3-distutils,
# need to turn off apport
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential,
  locales-all,
  python3.8-dev,
  python3.8-dbg,
  libpython3.8-testsuite,
  python3-gdbm-dbg,
  gdb,
  python3-distutils,
# need to turn off apport
Restrictions: needs-root allow-stderr

## python3.8 3.8.0

=== debian/changelog ===
python3.8 (3.8.0-3ubuntu1~18.04.2) bionic-security; urgency=medium

  * SECURITY UPDATE: Regular Expression Denial of Service
    - debian/patches/CVE-2020-8492.patch: updates a regular expression in the 
      urllib.request.AbsatrctBasicAuthHandler class which allows for 
      catastrophic backtracking and could result in a Denial of Service 
      condition.
    - CVE-2020-8492 
  * SECURITY UPDATE: Regular Expression Denial of Service
    - debian/patches/CVE-2021-3733.patch: updates a regular expression in the 
      urllib.request.AbstractBasicAuthHandler class which has a quadratic
      worst-case time complexity and could be abused by a malicious HTTP
      server to cause a Denial of Service condition for a client.
    - CVE-2021-3733 
  * SECURITY UPDATE: Denial of Service
    - debian/patches/CVE-2021-3737.patch: addresses the potential for the
      urllib http client to enter into an infinite loop and hang on a 100
      Continue response from a malicious server.
    - debian/patches/CVE-2021-3737_test-fix.patch: improves the regression
      test in Lib/test/test_httplib.py
    - CVE-2021-3737

 -- Ian Constantin <ian.constantin@canonical.com>  Thu, 09 Dec 2021 12:53:27 -0500

python3.8 (3.8.0-3~18.04.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Code execution from content received via HTTP
    - debian/patches/CVE-2020-27619.patch: no longer call eval() on
      content received via HTTP in Lib/test/multibytecodec_support.py.
    - CVE-2020-27619
  * SECURITY UPDATE: Buffer overflow
    - debian/patches/CVE-2021-3177.patch: replace snprintf with Python unicode
      formatting in ctypes param reprs in Lib/ctypes/test/test_parameters.py,
      Modules/_ctypes/callproc.c.
    - CVE-2021-3177

 -- Paulo Flabiano Smorigo <pfsmorigo@canonical.com>  Thu, 25 Feb 2021 22:10:10 +0000

python3.8 (3.8.0-3~18.04) bionic-proposed; urgency=medium

  * SRU: LP: #1835737. Backport the final Python 3.8.0 release.
  * Don't build the -doc package, outdated sphinx version in bionic.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 28 Oct 2019 17:14:01 +0100

python3.8 (3.8.0-3) unstable; urgency=medium

  * python3.8-dev: Depend on zlib1g-dev, needed to link as an
    embedded interpreter.

 -- Matthias Klose <doko@debian.org>  Sun, 27 Oct 2019 17:36:55 +0200

python3.8 (3.8.0-2) unstable; urgency=medium

  * Fix a symlink to the shared debug library.
  * Install the python3.8d-embed pkg-config file.
  * Don't ship the python3-embed pkg-config file.

 -- Matthias Klose <doko@debian.org>  Sun, 20 Oct 2019 18:00:25 +0200

python3.8 (3.8.0-1) unstable; urgency=medium

  * Python 3.8.0 release.

 -- Matthias Klose <doko@debian.org>  Tue, 15 Oct 2019 11:10:20 +0200

python3.8 (3.8.0~rc1-3) unstable; urgency=medium

  * Apply proposed patch for issue 38368. LP: #1847036. Addresses: #941650.

 -- Matthias Klose <doko@debian.org>  Wed, 09 Oct 2019 11:06:01 +0200

python3.8 (3.8.0~rc1-2) unstable; urgency=medium

  * Python 3.8.0 release candidate 1.
  * Refresh patches.
  * Update symbols files.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 02 Oct 2019 05:45:03 +0200

python3.8 (3.8.0~b4-1) unstable; urgency=medium

  * Python 3.8.0 beta 4 release.

 -- Matthias Klose <doko@debian.org>  Sat, 31 Aug 2019 16:07:24 +0200

python3.8 (3.8.0~b3-1) unstable; urgency=medium

  * Python 3.8.0 beta 3 release.
  * Fix FTCBFS: (Helmut Grohne). Closes: #932077.
    + Build-Depends, when cross compiling we need python3.8.
    + Export CC, because dtrace needs it.
    + Honour DEB_BUILD_OPTIONS=nocheck more thoroughly.
    + Fix up sysconfigdata-name.diff.
  * Implement the native thread ids for the Hurd and KFreeBSD (Samuel
    Thibault). Closes: #931624.
  * Enable pgo/lto builds on arm64. Addresses: #934812.
  * Update symbols files.
  * Don't propagate lto flags to the _sysconfigdata module. Addresses: #934771.
  * d/patches/issue35998.diff: Disable TLS1.3 in the client on all platforms
    rather than just reducing the payload size (Michael Hudson-Doyle).

 -- Matthias Klose <doko@debian.org>  Wed, 21 Aug 2019 17:32:52 +0200

python3.8 (3.8.0~b2-5) unstable; urgency=high

  * Bump standards version.
  * Revert the KFreeBSD and Hurd fix for PyThread_get_thread_native_id,
    and use the implementation from Python3.7.  Mark the symbol as linux only.
  * Don't encode the MACHDEP into the _sysconfigdata file name.

 -- Matthias Klose <doko@debian.org>  Thu, 11 Jul 2019 11:55:03 +0200

python3.8 (3.8.0~b2-4) unstable; urgency=medium

  * Fix the LTO build.

 -- Matthias Klose <doko@debian.org>  Sun, 07 Jul 2019 14:23:41 +0200

python3.8 (3.8.0~b2-3) unstable; urgency=medium

  * Define PY_HAVE_THREAD_NATIVE_ID for KFreeBSD and Hurd builds.
  * Fix issue #37504, building the texinfo docs (Dmitry Shachnev).
  * Enable LTO/PGO builds on some architectures.

 -- Matthias Klose <doko@debian.org>  Sat, 06 Jul 2019 12:00:08 +0200

python3.8 (3.8.0~b2-1) experimental; urgency=medium

  * Python 3.8.0 beta 2 release.
  * Refresh patches.
  * Update the symbols files.
  * Don't build the texinfo documentation, fails. See issue #37504.

 -- Matthias Klose <doko@debian.org>  Fri, 05 Jul 2019 11:20:35 +0200

python3.8 (3.8.0~b1-2) experimental; urgency=medium

  * Fix include links in python3.8-dbg.

 -- Matthias Klose <doko@debian.org>  Mon, 17 Jun 2019 11:41:06 +0200

python3.8 (3.8.0~b1-1) experimental; urgency=medium

  * Python 3.8.0 beta 1 release.
  * Refresh patches.
  * Add new importlib dependencies to python3-minimal.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Wed, 05 Jun 2019 11:23:02 +0200

python3.8 (3.8.0~a4-3) experimental; urgency=medium

  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Wed, 15 May 2019 00:30:25 +0200

python3.8 (3.8.0~a4-2) experimental; urgency=medium

  * Update to 20190514 from the trunk.
  * Fix interpreter name in the -dbg autopkg tests.
  * Enable dtrace/USDT probe support (--with-dtrace) and build-dep on


=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: python3.8
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
   quilt, autoconf,
   lsb-release, sharutils,
-  libreadline-dev, libncursesw5-dev (>= 5.3), 
+  libreadline-dev, libncursesw5-dev (>= 5.3), g++-8,
   zlib1g-dev, libbz2-dev, liblzma-dev,
   libgdbm-dev, libdb-dev,
   tk-dev, blt-dev (>= 2.4z), libssl-dev,
@@ -13,11 +14,12 @@
   libbluetooth-dev [linux-any] <!pkg.python3.8.nobluetooth>,
   locales-all,
   libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
-  libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
-  mime-support, netbase, bzip2, time, python3:any,
-  net-tools, xvfb, xauth
-Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
-Standards-Version: 4.3.0
+  libgpm2 [linux-any],
+  mime-support, netbase, bzip2, time, python3:any, python3.8:any <cross>,
+  net-tools, xvfb <!nocheck>, xauth <!nocheck>,
+  systemtap-sdt-dev
+Build-Depends-Indep: texinfo
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/cpython-team/python3
 Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
 XS-Testsuite: autopkgtest
@@ -89,7 +91,8 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: libpython3.8-stdlib
-Conflicts: binfmt-support (<< 1.1.2)
+Breaks: libpython3.8-stdlib (<< 3.8.0~b1-1~)
+Conflicts: binfmt-support (<< 1.1.2), libpython3.8-stdlib (<< 3.8.0~b1-1~)
 Description: Minimal subset of the Python language (version 3.8)
  This package contains some essential modules. It is normally not
  used on it's own, but as a dependency of python3.8-minimal.
@@ -119,7 +122,11 @@
 Package: python3.8-dev
 Architecture: any
 Multi-Arch: allowed
-Depends: python3.8 (= ${binary:Version}), libpython3.8-dev (= ${binary:Version}), libpython3.8 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
+Depends: python3.8 (= ${binary:Version}),
+  libpython3.8-dev (= ${binary:Version}),
+  libpython3.8 (= ${binary:Version}),
+  libexpat1-dev, zlib1g-dev,
+  ${shlibs:Depends}, ${misc:Depends}
 Recommends: libc6-dev | libc-dev
 Description: Header files and a static library for Python (v3.8)
  Header files, a static library and development tools for building

=== debian/rules ===
--- 
+++ 
@@ -153,6 +153,9 @@
 AR=$(DEB_HOST_GNU_TYPE)-ar
 RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib
 
+# configure and dtrace consume these
+export CC CXX
+
 DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
 DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
 DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
@@ -171,17 +174,23 @@
 
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
   ifeq ($(DEB_HOST_ARCH_OS),linux)
-    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
+    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
       with_pgo := yes
     endif
   endif
 endif
 
-ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
+ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
   with_lto := yes
 endif
-with_pgo :=
-with_lto :=
+
+ifneq (,$(findstring nopgo, $(DEB_BUILD_OPTIONS)))
+  with_pgo :=
+endif
+
+ifneq (,$(findstring nolto, $(DEB_BUILD_OPTIONS)))
+  with_lto :=
+endif
 
 ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
     OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
@@ -190,8 +199,9 @@
     with_lto =
 endif
 
+BASE_LTO_CFLAGS = -g -fwrapv -O3
 ifeq ($(with_lto),yes)
-    LTO_CFLAGS = -g -flto -fuse-linker-plugin
+    LTO_CFLAGS = $(BASE_LTO_CFLAGS) -flto -fuse-linker-plugin
     with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
 			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
     ifeq ($(with_fat_lto),yes)
@@ -204,8 +214,9 @@
 
 sysconfig_substflags = \
 	-e 's,gcc-8,gcc,;s,g++-8,g++,' \
+	$(if $(with_lto),$(foreach i,-flto -fuse-linker-plugin -ffat-lto-objects,-e 's/$(i)//g')) \
 	-e '/^OPT/s,-O3,-O2,' \
-	-e 's/-O3/-O2/g;s/$(LTO_CFLAGS)//g' \
+	-e 's/-O3/-O2/g' \
 	-e 's/-fprofile-use *-fprofile-correction//g' \
 	-e 's/-fstack-protector /-fstack-protector-strong /g' \
 	-e 's/-specs=[^ ]*//g' \
@@ -233,17 +244,3 @@
 
 # package names and directories
 p_base	:= $(PVER)
-p_min	:= $(PVER)-minimal
-p_lib	:= lib$(PVER)
-p_tk	:= $(PVER)-tk
-p_dev	:= $(PVER)-dev
-p_exam	:= $(PVER)-examples
-p_idle	:= idle-$(PVER)
-p_doc	:= $(PVER)-doc
-p_dbg	:= $(PVER)-dbg
-p_udeb	:= $(PVER)-udeb
-p_venv	:= $(PVER)-venv
-
-p_lbase	:= lib$(PVER)-stdlib
-p_lmin	:= lib$(PVER)-minimal
-p_ldev	:= lib$(PVER)-dev

=== debian/tests/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
   python3-distutils,
   python3-tk,
   idle-python3.8,
+  systemtap-sdt-dev,
 # need to turn off apport
 Restrictions: needs-root
 
@@ -20,6 +21,7 @@
   python3-distutils,
   python3-tk-dbg,
   idle-python3.8,
+  systemtap-sdt-dev,
 # need to turn off apport
 Restrictions: needs-root

## python3.8 3.8.2~rc1

=== debian/changelog ===
python3.8 (3.8.2~rc1-1) unstable; urgency=medium

  * Python 3.8.2 release candidate 1.
  * Make autopkgtests cross-test-friendly (Steve Langasek).
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Tue, 11 Feb 2020 16:26:48 +0100

python3.8 (3.8.1-2) unstable; urgency=medium

  * Fix KFreeBSD builds (James Cowgill).

 -- Matthias Klose <doko@debian.org>  Mon, 06 Jan 2020 09:48:53 +0100

python3.8 (3.8.1-1) unstable; urgency=medium

  * Python 3.8.1 release.

 -- Matthias Klose <doko@debian.org>  Thu, 19 Dec 2019 10:21:09 +0100

python3.8 (3.8.1~rc1-1) unstable; urgency=medium

  * Python 3.8.1 release candidate 1.

 -- Matthias Klose <doko@debian.org>  Tue, 10 Dec 2019 10:38:12 +0100

python3.8 (3.8.0-5) unstable; urgency=medium

  * Update to 20191123 from the 3.8 branch.
  * libpython3.8-dbg: Provide a python-$(VER)-dbg-embed.pc pkg-config file.
    Closes: #944852.

 -- Matthias Klose <doko@debian.org>  Sat, 23 Nov 2019 05:55:55 +0100

python3.8 (3.8.0-4) unstable; urgency=medium

  * Move the test/ann_module{,2,3} modules into libpython-stdlib.
    Closes: #944303.
  * Annote python-examples dependency on python.

 -- Matthias Klose <doko@debian.org>  Thu, 07 Nov 2019 16:14:28 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: python3.8
 Section: python
 Priority: optional
-Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
   quilt, autoconf,
   lsb-release, sharutils,
-  libreadline-dev, libncursesw5-dev (>= 5.3), g++-8,
+  libreadline-dev, libncursesw5-dev (>= 5.3), 
   zlib1g-dev, libbz2-dev, liblzma-dev,
   libgdbm-dev, libdb-dev,
   tk-dev, blt-dev (>= 2.4z), libssl-dev,
@@ -18,8 +17,8 @@
   mime-support, netbase, bzip2, time, python3:any, python3.8:any <cross>,
   net-tools, xvfb <!nocheck>, xauth <!nocheck>,
   systemtap-sdt-dev
-Build-Depends-Indep: texinfo
-Standards-Version: 4.4.1
+Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/cpython-team/python3
 Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
 XS-Testsuite: autopkgtest
@@ -60,6 +59,8 @@
 Multi-Arch: same
 Priority: optional
 Pre-Depends: ${misc:Pre-Depends}
+Breaks: libpython3.8-testsuite (<< 3.8.0-4)
+Replaces: libpython3.8-testsuite (<< 3.8.0-4)
 Depends: libpython3.8-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
 Description: Interactive high-level object-oriented language (standard library, version 3.8)
  Python is a high-level, interactive, object-oriented language. Its 3.8 version
@@ -114,7 +115,7 @@
 
 Package: python3.8-examples
 Architecture: all
-Depends: python3.8 (>= ${source:Version}), ${misc:Depends}
+Depends: python3.8:any (>= ${source:Version}), ${misc:Depends}
 Description: Examples for the Python language (v3.8)
  Examples, Demos and Tools for Python (v3.8). These are files included in
  the upstream Python distribution (v3.8).
